<?php
/**
 * @version             1.0 2010-01-05
 * @package             K2
 * @author		Olivier Nolbert http://www.jiliko.net
 * @copyright   	Copyright (c) 2009 - 2010 Jiliko 
 * @license             GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */

// no direct access
defined('_JEXEC') or die('Restricted access');
JLoader::register('K2Plugin',JPATH_ADMINISTRATOR.DS.'components'.DS.'com_k2'.DS.'lib'.DS.'k2plugin.php');

class plgK2OneCssPerK2Template extends K2Plugin {

        function plgK2OneCssPerK2Template(&$subject, $params) {
                parent::__construct($subject, $params);
        }
	function onK2PrepareContent( & $item, & $params, $limitstart) {
		global $mainframe;
	}

	function onK2AfterDisplay( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2BeforeDisplay( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2AfterDisplayTitle( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2BeforeDisplayContent( & $item, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function onK2AfterDisplayContent( & $item, & $params, $limitstart) {
		global $mainframe;
		// Call loadCss function if we're in the k2 item view
		$view=JRequest::getCmd('view');
		if( $view == 'item' ) $this->loadCss($params);	
		return '';
	}

	function onK2CategoryDisplay( & $category, & $params, $limitstart) {
		global $mainframe;
		// Call loadCss function if we're in the k2 itemlist view and layout != 'category'.
		// This layout displays more than one category and so the event is triggered for each specific template.
		// That's not what we want
		$view=JRequest::getCmd('view');
		$layout = JRequest::getCmd('layout');
		if($view == 'itemlist' && $layout != 'category') $this->loadCss($params);
		return '';
	}

	// Event to display in the frontend the YouTube URL as entered in the user form
	function onK2UserDisplay( & $user, & $params, $limitstart) {
		global $mainframe;
		return '';
	}

	function loadCss($params) {
		global $mainframe;
	
		// If a specific template is set, we do the job
		if($params->get('theme')) {
		  $doc =& JFactory::getDocument();
		  //We add the css file to the head of the document.
		  $doc->addStyleSheet(JURI::base().'templates'.DS.$mainframe->getTemplate().DS.'html'.DS.'com_k2'.DS.'templates'.DS.$params->get('theme').DS.$params->get('theme').'_style.css');
		  
		  //We load the plugin parameters
		  $plugin =& JPluginHelper::GetPlugin('k2', 'onecssperk2template');
		  $pluginParams = new JParameter($plugin->params);
		  
		  //If we DON'T want to keep the k2 css loaded
		  if(!$pluginParams->get('keepk2css',1)) {
		    //We load the head data of the document in an array
		    $tabHead = $doc->getHeadData();

		    //For each stylesheets loaded, we check the key (the path & name of the css file)
		    foreach($tabHead['styleSheets'] as $key => $styleSheet){
		      if( strpos($key, 'components'.DS.'com_k2'.DS.'css'.DS.'k2.css')) {
			//The entry of the css file is deleted
			unset($tabHead['styleSheets'][$key]);
			break;
		      }
		    } 
		    //The new head data is loaded in the document
		    $doc->setHeadData($tabHead);
		  }
		}
	}
} // END CLASS
